Package | Class | Use | Tree | Deprecated | Index | Help
| log4jdbc3 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.log4jdbc
Class StatementSpy

    java.lang.Object
      net.sf.log4jdbc.StatementSpy

All Implemented Interfaces:
  Spy, Statement

Direct Known Subclasses:
  PreparedStatementSpy

public class StatementSpy
extends Object
implements Statement, Spy

Wraps a Statement and reports method calls, returns and exceptions.

Author:
  Arthur Blake

Field Summary
`protected ConnectionSpy` | `connectionSpy` The Connection that created this Statement.
`protected List` | `currentBatch` Tracking of current batch (see addBatch, clearBatch and executeBatch) //todo: should access to this List be synchronized?
`protected Statement` | `realStatement` The real statement that this StatementSpy wraps.

Fields inherited from interface java.sql.Statement
`CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

Constructor Summary
`StatementSpy(ConnectionSpy connectionSpy, Statement realStatement)` Create a StatementSpy that wraps another Statement, for the purpose of logging all method calls, sql, exceptions and return values.

Method Summary
`void` | `addBatch(String sql)` Adds the given SQL command to the current list of commmands for this `Statement` object.
`void` | `cancel()` Cancels this `Statement` object if both the DBMS and driver support aborting an SQL statement.
`void` | `clearBatch()` Empties this `Statement` object's current list of SQL commands.
`void` | `clearWarnings()` Clears all the warnings reported on this `Statement` object.
`void` | `close()` Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed.
`boolean` | `execute(String sql)` Executes the given SQL statement, which may return multiple results.
`boolean` | `execute(String sql, int autoGeneratedKeys)` Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval.
`boolean` | `execute(String sql, int[] columnIndexes)` Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`boolean` | `execute(String sql, String[] columnNames)` Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`int[]` | `executeBatch()` Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts.
`ResultSet` | `executeQuery(String sql)` Executes the given SQL statement, which returns a single `ResultSet` object.
`int` | `executeUpdate(String sql)` Executes the given SQL statement, which may be an `INSERT`, `UPDATE`, or `DELETE` statement or an SQL statement that returns nothing, such as an SQL DDL statement.
`int` | `executeUpdate(String sql, int autoGeneratedKeys)` Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval.
`int` | `executeUpdate(String sql, int[] columnIndexes)` Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`int` | `executeUpdate(String sql, String[] columnNames)` Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval.
`String` | `getClassType()` Get the type of class being spied upon.
`Connection` | `getConnection()` Retrieves the `Connection` object that produced this `Statement` object.
`int` | `getConnectionNumber()` Get the connection number.
`int` | `getFetchDirection()` Retrieves the direction for fetching rows from database tables that is the default for result sets generated from this `Statement` object.
`int` | `getFetchSize()` Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object.
`ResultSet` | `getGeneratedKeys()` Retrieves any auto-generated keys created as a result of executing this `Statement` object.
`int` | `getMaxFieldSize()` Retrieves the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object.
`int` | `getMaxRows()` Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain.
`boolean` | `getMoreResults()` Moves to this `Statement` object's next result, returns `true` if it is a `ResultSet` object, and implicitly closes any current `ResultSet` object(s) obtained with the method `getResultSet`.
`boolean` | `getMoreResults(int current)` Moves to this `Statement` object's next result, deals with any current `ResultSet` object(s) according to the instructions specified by the given flag, and returns `true` if the next result is a `ResultSet` object.
`int` | `getQueryTimeout()` Retrieves the number of seconds the driver will wait for a `Statement` object to execute.
`ResultSet` | `getResultSet()` Retrieves the current result as a `ResultSet` object.
`int` | `getResultSetConcurrency()` Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.
`int` | `getResultSetHoldability()` Retrieves the result set holdability for `ResultSet` objects generated by this `Statement` object.
`int` | `getResultSetType()` Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.
`int` | `getUpdateCount()` Retrieves the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned.
`SQLWarning` | `getWarnings()` Retrieves the first warning reported by calls on this `Statement` object.
`protected void` | `reportAllReturns(String methodCall, String msg)` Report (for logging) that a method returned.
`protected void` | `reportException(String methodCall, SQLException exception)` Report an exception to be logged.
`protected void` | `reportException(String methodCall, SQLException exception, String sql)` Report an exception to be logged.
`protected void` | `reportException(String methodCall, SQLException exception, String sql, long execTime)` Report an exception to be logged which includes timing data on a sql failure.
`protected void` | `reportReturn(String methodCall)` Conveniance method to report (for logging) that a method returned (void return type).
`protected boolean` | `reportReturn(String methodCall, boolean value)` Conveniance method to report (for logging) that a method returned a boolean value.
`protected byte` | `reportReturn(String methodCall, byte value)` Conveniance method to report (for logging) that a method returned a byte value.
`protected double` | `reportReturn(String methodCall, double value)` Conveniance method to report (for logging) that a method returned a double value.
`protected float` | `reportReturn(String methodCall, float value)` Conveniance method to report (for logging) that a method returned a float value.
`protected int` | `reportReturn(String methodCall, int value)` Conveniance method to report (for logging) that a method returned a int value.
`protected long` | `reportReturn(String methodCall, long value)` Conveniance method to report (for logging) that a method returned a long value.
`protected Object` | `reportReturn(String methodCall, Object value)` Conveniance method to report (for logging) that a method returned an Object.
`protected short` | `reportReturn(String methodCall, short value)` Conveniance method to report (for logging) that a method returned a short value.
`protected void` | `reportSql(String sql, String methodCall)` Report SQL for logging.
`protected void` | `reportSqlTiming(long execTime, String sql, String methodCall)` Report SQL for logging.
`protected void` | `reportStatementSql(String sql, String methodCall)` Report SQL for logging with a warning that it was generated from a statement.
`protected void` | `reportStatementSqlTiming(long execTime, String sql, String methodCall)` Report SQL for logging with a warning that it was generated from a statement.
`void` | `setCursorName(String name)` Sets the SQL cursor name to the given `String`, which will be used by subsequent `Statement` object `execute` methods.
`void` | `setEscapeProcessing(boolean enable)` Sets escape processing on or off.
`void` | `setFetchDirection(int direction)` Gives the driver a hint as to the direction in which rows will be processed in `ResultSet` objects created using this `Statement` object.
`void` | `setFetchSize(int rows)` Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed.
`void` | `setMaxFieldSize(int max)` Sets the limit for the maximum number of bytes in a `ResultSet` column storing character or binary values to the given number of bytes.
`void` | `setMaxRows(int max)` Sets the limit for the maximum number of rows that any `ResultSet` object can contain to the given number.
`void` | `setQueryTimeout(int seconds)` Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### connectionSpy

    protected ConnectionSpy connectionSpy

  The Connection that created this Statement.

### realStatement

    protected Statement realStatement

  The real statement that this StatementSpy wraps.

### currentBatch

    protected List currentBatch

  Tracking of current batch (see addBatch, clearBatch and executeBatch) //todo: should access to this List be synchronized?

Constructor Detail

### StatementSpy

    public StatementSpy(ConnectionSpy connectionSpy,
                        Statement realStatement)

  Create a StatementSpy that wraps another Statement, for the purpose of logging all method calls, sql, exceptions and return values.

Parameters:
  `connectionSpy` - Connection that created this Statement.
  `realStatement` - real underlying Statement that this StatementSpy wraps.

Method Detail

### getClassType

    public String getClassType()

  Description copied from interface: `Spy`
  Get the type of class being spied upon. For example, "Statement", "ResultSet", etc.

  Specified by:
    `getClassType` in interface `Spy`
  Returns:
    a description of the type of class being spied upon.

### getConnectionNumber

    public int getConnectionNumber()

  Description copied from interface: `Spy`
  Get the connection number. In general, this is used to track which underlying connection is being used from the database. The number will be incremented each time a new Connection is retrieved from the real underlying jdbc driver. This is useful for debugging and tracking down problems with connection pooling.

  Specified by:
    `getConnectionNumber` in interface `Spy`
  Returns:
    the connection instance number.

### reportException

    protected void reportException(String methodCall,
                                   SQLException exception,
                                   String sql,
                                   long execTime)

  Report an exception to be logged which includes timing data on a sql failure.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that generated the exception.
    `exception` - exception that was generated
    `sql` - SQL associated with the call.
    `execTime` - amount of time that the jdbc driver was chugging on the SQL before it threw an exception.

### reportException

    protected void reportException(String methodCall,
                                   SQLException exception,
                                   String sql)

  Report an exception to be logged.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that generated the exception.
    `exception` - exception that was generated
    `sql` - SQL associated with the call.

### reportException

    protected void reportException(String methodCall,
                                   SQLException exception)

  Report an exception to be logged.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that generated the exception.
    `exception` - exception that was generated

### reportAllReturns

    protected void reportAllReturns(String methodCall,
                                    String msg)

  Report (for logging) that a method returned. All the other reportReturn methods are conveniance methods that call this method.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `msg` - description of what the return value that was returned. may be an empty String for void return types.

### reportReturn

    protected boolean reportReturn(String methodCall,
                                   boolean value)

  Conveniance method to report (for logging) that a method returned a boolean value.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - boolean return value.
  Returns:
    the boolean return value as passed in.

### reportReturn

    protected byte reportReturn(String methodCall,
                                byte value)

  Conveniance method to report (for logging) that a method returned a byte value.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - byte return value.
  Returns:
    the byte return value as passed in.

### reportReturn

    protected int reportReturn(String methodCall,
                               int value)

  Conveniance method to report (for logging) that a method returned a int value.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - int return value.
  Returns:
    the int return value as passed in.

### reportReturn

    protected double reportReturn(String methodCall,
                                  double value)

  Conveniance method to report (for logging) that a method returned a double value.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - double return value.
  Returns:
    the double return value as passed in.

### reportReturn

    protected short reportReturn(String methodCall,
                                 short value)

  Conveniance method to report (for logging) that a method returned a short value.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - short return value.
  Returns:
    the short return value as passed in.

### reportReturn

    protected long reportReturn(String methodCall,
                                long value)

  Conveniance method to report (for logging) that a method returned a long value.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - long return value.
  Returns:
    the long return value as passed in.

### reportReturn

    protected float reportReturn(String methodCall,
                                 float value)

  Conveniance method to report (for logging) that a method returned a float value.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - float return value.
  Returns:
    the float return value as passed in.

### reportReturn

    protected Object reportReturn(String methodCall,
                                  Object value)

  Conveniance method to report (for logging) that a method returned an Object.

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.
    `value` - return Object.
  Returns:
    the return Object as passed in.

### reportReturn

    protected void reportReturn(String methodCall)

  Conveniance method to report (for logging) that a method returned (void return type).

  Parameters:
    `methodCall` - description of method call and arguments passed to it that returned.

### reportStatementSql

    protected void reportStatementSql(String sql,
                                      String methodCall)

  Report SQL for logging with a warning that it was generated from a statement.

  Parameters:
    `sql` - the SQL being run
    `methodCall` - the name of the method that was running the SQL

### reportStatementSqlTiming

    protected void reportStatementSqlTiming(long execTime,
                                            String sql,
                                            String methodCall)

  Report SQL for logging with a warning that it was generated from a statement.

  Parameters:
    `execTime` - execution time in msec.
    `sql` - the SQL being run
    `methodCall` - the name of the method that was running the SQL

### reportSqlTiming

    protected void reportSqlTiming(long execTime,
                                   String sql,
                                   String methodCall)

  Report SQL for logging.

  Parameters:
    `execTime` - execution time in msec.
    `sql` - the SQL being run
    `methodCall` - the name of the method that was running the SQL

### reportSql

    protected void reportSql(String sql,
                             String methodCall)

  Report SQL for logging.

  Parameters:
    `sql` - the SQL being run
    `methodCall` - the name of the method that was running the SQL

### getWarnings

    public SQLWarning getWarnings()
                           throws SQLException

  Description copied from interface: `Statement`
  Retrieves the first warning reported by calls on this `Statement` object. Subsequent `Statement` object warnings will be chained to this `SQLWarning` object.

  The warning chain is automatically cleared each time a statement is (re)executed. This method may not be called on a closed `Statement` object; doing so will cause an `SQLException` to be thrown.

  Note: If you are processing a `ResultSet` object, any warnings associated with reads on that `ResultSet` object will be chained on it rather than on the `Statement` object that produced it.

  Specified by:
    `getWarnings` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    the first `SQLWarning` object or `null` if there are no warnings

### executeUpdate

    public int executeUpdate(String sql,
                             String[] columnNames)
                      throws SQLException

  Description copied from interface: `Statement`
  Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. The driver will ignore the array if the SQL statement is not an `INSERT` statement.

  Specified by:
    `executeUpdate` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `sql` - an SQL `INSERT`, `UPDATE` or `DELETE` statement or an SQL statement that returns nothing
    `columnNames` - an array of the names of the columns that should be returned from the inserted row
  Returns:
    either the row count for `INSERT`, `UPDATE`, or `DELETE` statements, or 0 for SQL statements that return nothing

### execute

    public boolean execute(String sql,
                           String[] columnNames)
                    throws SQLException

  Description copied from interface: `Statement`
  Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the names of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the given SQL statement is not an `INSERT` statement.

  In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

  The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

  Specified by:
    `execute` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `sql` - any SQL statement
    `columnNames` - an array of the names of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
  Returns:
    `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
  See Also:
    `Statement.getResultSet()`, `Statement.getUpdateCount()`, `Statement.getMoreResults()`, `Statement.getGeneratedKeys()`

### setMaxRows

    public void setMaxRows(int max)
                    throws SQLException

  Description copied from interface: `Statement`
  Sets the limit for the maximum number of rows that any `ResultSet` object can contain to the given number. If the limit is exceeded, the excess rows are silently dropped.

  Specified by:
    `setMaxRows` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `max` - the new max rows limit; zero means there is no limit
  See Also:
    `Statement.getMaxRows()`

### getMoreResults

    public boolean getMoreResults()
                           throws SQLException

  Description copied from interface: `Statement`
  Moves to this `Statement` object's next result, returns `true` if it is a `ResultSet` object, and implicitly closes any current `ResultSet` object(s) obtained with the method `getResultSet`.

  There are no more results when the following is true:

           // stmt is a Statement object
           ((stmt.getMoreResults() == false) && (stmt.getUpdateCount() == -1))

  Specified by:
    `getMoreResults` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
  See Also:
    `Statement.execute(java.lang.String)`

### clearWarnings

    public void clearWarnings()
                       throws SQLException

  Description copied from interface: `Statement`
  Clears all the warnings reported on this `Statement` object. After a call to this method, the method `getWarnings` will return `null` until a new warning is reported for this `Statement` object.

  Specified by:
    `clearWarnings` in interface `Statement`
  Throws:
    `SQLException`

### addBatch

    public void addBatch(String sql)
                  throws SQLException

  Description copied from interface: `Statement`
  Adds the given SQL command to the current list of commmands for this `Statement` object. The commands in this list can be executed as a batch by calling the method `executeBatch`.

  NOTE: This method is optional.

  Specified by:
    `addBatch` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `sql` - typically this is a static SQL `INSERT` or `UPDATE` statement
  See Also:
    `Statement.executeBatch()`

### getResultSetType

    public int getResultSetType()
                         throws SQLException

  Description copied from interface: `Statement`
  Retrieves the result set type for `ResultSet` objects generated by this `Statement` object.

  Specified by:
    `getResultSetType` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    one of `ResultSet.TYPE_FORWARD_ONLY`, `ResultSet.TYPE_SCROLL_INSENSITIVE`, or `ResultSet.TYPE_SCROLL_SENSITIVE`

### clearBatch

    public void clearBatch()
                    throws SQLException

  Description copied from interface: `Statement`
  Empties this `Statement` object's current list of SQL commands.

  NOTE: This method is optional.

  Specified by:
    `clearBatch` in interface `Statement`
  Throws:
    `SQLException`
  See Also:
    `Statement.addBatch(java.lang.String)`

### setFetchDirection

    public void setFetchDirection(int direction)
                           throws SQLException

  Description copied from interface: `Statement`
  Gives the driver a hint as to the direction in which rows will be processed in `ResultSet` objects created using this `Statement` object. The default value is `ResultSet.FETCH_FORWARD`.

  Note that this method sets the default fetch direction for result sets generated by this `Statement` object. Each result set has its own methods for getting and setting its own fetch direction.

  Specified by:
    `setFetchDirection` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `direction` - the initial direction for processing rows
  See Also:
    `Statement.getFetchDirection()`

### executeBatch

    public int[] executeBatch()
                       throws SQLException

  Description copied from interface: `Statement`
  Submits a batch of commands to the database for execution and if all commands execute successfully, returns an array of update counts. The `int` elements of the array that is returned are ordered to correspond to the commands in the batch, which are ordered according to the order in which they were added to the batch. The elements in the array returned by the method `executeBatch` may be one of the following:
  1. A number greater than or equal to zero -- indicates that the command was processed successfully and is an update count giving the number of rows in the database that were affected by the command's execution
  2. A value of `SUCCESS_NO_INFO` -- indicates that the command was processed successfully but that the number of rows affected is unknown

     If one of the commands in a batch update fails to execute properly, this method throws a `BatchUpdateException`, and a JDBC driver may or may not continue to process the remaining commands in the batch. However, the driver's behavior must be consistent with a particular DBMS, either always continuing to process commands or never continuing to process commands. If the driver continues processing after a failure, the array returned by the method `BatchUpdateException.getUpdateCounts` will contain as many elements as there are commands in the batch, and at least one of the elements will be the following:

  3. A value of `EXECUTE_FAILED` -- indicates that the command failed to execute successfully and occurs only if a driver continues to process commands after a command fails

  A driver is not required to implement this method. The possible implementations and return values have been modified in the Java 2 SDK, Standard Edition, version 1.3 to accommodate the option of continuing to proccess commands in a batch update after a `BatchUpdateException` obejct has been thrown.

  Specified by:
    `executeBatch` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    an array of update counts containing one element for each command in the batch. The elements of the array are ordered according to the order in which commands were added to the batch.

### setFetchSize

    public void setFetchSize(int rows)
                      throws SQLException

  Description copied from interface: `Statement`
  Gives the JDBC driver a hint as to the number of rows that should be fetched from the database when more rows are needed. The number of rows specified affects only result sets created using this statement. If the value specified is zero, then the hint is ignored. The default value is zero.

  Specified by:
    `setFetchSize` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `rows` - the number of rows to fetch
  See Also:
    `Statement.getFetchSize()`

### getQueryTimeout

    public int getQueryTimeout()
                        throws SQLException

  Description copied from interface: `Statement`
  Retrieves the number of seconds the driver will wait for a `Statement` object to execute. If the limit is exceeded, a `SQLException` is thrown.

  Specified by:
    `getQueryTimeout` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    the current query timeout limit in seconds; zero means there is no limit
  See Also:
    `Statement.setQueryTimeout(int)`

### getConnection

    public Connection getConnection()
                             throws SQLException

  Description copied from interface: `Statement`
  Retrieves the `Connection` object that produced this `Statement` object.

  Specified by:
    `getConnection` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    the connection that produced this statement

### getGeneratedKeys

    public ResultSet getGeneratedKeys()
                               throws SQLException

  Description copied from interface: `Statement`
  Retrieves any auto-generated keys created as a result of executing this `Statement` object. If this `Statement` object did not generate any keys, an empty `ResultSet` object is returned.

  Specified by:
    `getGeneratedKeys` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    a `ResultSet` object containing the auto-generated key(s) generated by the execution of this `Statement` object

### setEscapeProcessing

    public void setEscapeProcessing(boolean enable)
                             throws SQLException

  Description copied from interface: `Statement`
  Sets escape processing on or off. If escape scanning is on (the default), the driver will do escape substitution before sending the SQL statement to the database. Note: Since prepared statements have usually been parsed prior to making this call, disabling escape processing for `PreparedStatements` objects will have no effect.

  Specified by:
    `setEscapeProcessing` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `enable` - `true` to enable escape processing; `false` to disable it

### getFetchDirection

    public int getFetchDirection()
                          throws SQLException

  Description copied from interface: `Statement`
  Retrieves the direction for fetching rows from database tables that is the default for result sets generated from this `Statement` object. If this `Statement` object has not set a fetch direction by calling the method `setFetchDirection`, the return value is implementation-specific.

  Specified by:
    `getFetchDirection` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    the default fetch direction for result sets generated from this `Statement` object
  See Also:
    `Statement.setFetchDirection(int)`

### setQueryTimeout

    public void setQueryTimeout(int seconds)
                         throws SQLException

  Description copied from interface: `Statement`
  Sets the number of seconds the driver will wait for a `Statement` object to execute to the given number of seconds. If the limit is exceeded, an `SQLException` is thrown.

  Specified by:
    `setQueryTimeout` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `seconds` - the new query timeout limit in seconds; zero means there is no limit
  See Also:
    `Statement.getQueryTimeout()`

### getMoreResults

    public boolean getMoreResults(int current)
                           throws SQLException

  Description copied from interface: `Statement`
  Moves to this `Statement` object's next result, deals with any current `ResultSet` object(s) according to the instructions specified by the given flag, and returns `true` if the next result is a `ResultSet` object.

  There are no more results when the following is true:

           // stmt is a Statement object
           ((stmt.getMoreResults() == false) && (stmt.getUpdateCount() == -1))

  Specified by:
    `getMoreResults` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `current` - one of the following `Statement` constants indicating what should happen to current `ResultSet` objects obtained using the method `getResultSet`: `Statement.CLOSE_CURRENT_RESULT`, `Statement.KEEP_CURRENT_RESULT`, or `Statement.CLOSE_ALL_RESULTS`
  Returns:
    `true` if the next result is a `ResultSet` object; `false` if it is an update count or there are no more results
  See Also:
    `Statement.execute(java.lang.String)`

### executeQuery

    public ResultSet executeQuery(String sql)
                           throws SQLException

  Description copied from interface: `Statement`
  Executes the given SQL statement, which returns a single `ResultSet` object.

  Specified by:
    `executeQuery` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `sql` - an SQL statement to be sent to the database, typically a static SQL `SELECT` statement
  Returns:
    a `ResultSet` object that contains the data produced by the given query; never `null`

### getMaxFieldSize

    public int getMaxFieldSize()
                        throws SQLException

  Description copied from interface: `Statement`
  Retrieves the maximum number of bytes that can be returned for character and binary column values in a `ResultSet` object produced by this `Statement` object. This limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, and `LONGVARCHAR` columns. If the limit is exceeded, the excess data is silently discarded.

  Specified by:
    `getMaxFieldSize` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    the current column size limit for columns storing character and binary values; zero means there is no limit
  See Also:
    `Statement.setMaxFieldSize(int)`

### executeUpdate

    public int executeUpdate(String sql)
                      throws SQLException

  Description copied from interface: `Statement`
  Executes the given SQL statement, which may be an `INSERT`, `UPDATE`, or `DELETE` statement or an SQL statement that returns nothing, such as an SQL DDL statement.

  Specified by:
    `executeUpdate` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `sql` - an SQL `INSERT`, `UPDATE` or `DELETE` statement or an SQL statement that returns nothing
  Returns:
    either the row count for `INSERT`, `UPDATE` or `DELETE` statements, or `0` for SQL statements that return nothing

### cancel

    public void cancel()
                throws SQLException

  Description copied from interface: `Statement`
  Cancels this `Statement` object if both the DBMS and driver support aborting an SQL statement. This method can be used by one thread to cancel a statement that is being executed by another thread.

  Specified by:
    `cancel` in interface `Statement`
  Throws:
    `SQLException`

### setCursorName

    public void setCursorName(String name)
                       throws SQLException

  Description copied from interface: `Statement`
  Sets the SQL cursor name to the given `String`, which will be used by subsequent `Statement` object `execute` methods. This name can then be used in SQL positioned update or delete statements to identify the current row in the `ResultSet` object generated by this statement. If the database does not support positioned update/delete, this method is a noop. To insure that a cursor has the proper isolation level to support updates, the cursor's `SELECT` statement should have the form `SELECT FOR UPDATE`. If `FOR UPDATE` is not present, positioned updates may fail.

  Note: By definition, the execution of positioned updates and deletes must be done by a different `Statement` object than the one that generated the `ResultSet` object being used for positioning. Also, cursor names must be unique within a connection.

  Specified by:
    `setCursorName` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `name` - the new cursor name, which must be unique within a connection

### getFetchSize

    public int getFetchSize()
                     throws SQLException

  Description copied from interface: `Statement`
  Retrieves the number of result set rows that is the default fetch size for `ResultSet` objects generated from this `Statement` object. If this `Statement` object has not set a fetch size by calling the method `setFetchSize`, the return value is implementation-specific.

  Specified by:
    `getFetchSize` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    the default fetch size for result sets generated from this `Statement` object
  See Also:
    `Statement.setFetchSize(int)`

### getResultSetConcurrency

    public int getResultSetConcurrency()
                                throws SQLException

  Description copied from interface: `Statement`
  Retrieves the result set concurrency for `ResultSet` objects generated by this `Statement` object.

  Specified by:
    `getResultSetConcurrency` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    either `ResultSet.CONCUR_READ_ONLY` or `ResultSet.CONCUR_UPDATABLE`

### getResultSetHoldability

    public int getResultSetHoldability()
                                throws SQLException

  Description copied from interface: `Statement`
  Retrieves the result set holdability for `ResultSet` objects generated by this `Statement` object.

  Specified by:
    `getResultSetHoldability` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    either `ResultSet.HOLD_CURSORS_OVER_COMMIT` or `ResultSet.CLOSE_CURSORS_AT_COMMIT`

### setMaxFieldSize

    public void setMaxFieldSize(int max)
                         throws SQLException

  Description copied from interface: `Statement`
  Sets the limit for the maximum number of bytes in a `ResultSet` column storing character or binary values to the given number of bytes. This limit applies only to `BINARY`, `VARBINARY`, `LONGVARBINARY`, `CHAR`, `VARCHAR`, and `LONGVARCHAR` fields. If the limit is exceeded, the excess data is silently discarded. For maximum portability, use values greater than 256.

  Specified by:
    `setMaxFieldSize` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `max` - the new column size limit in bytes; zero means there is no limit
  See Also:
    `Statement.getMaxFieldSize()`

### execute

    public boolean execute(String sql)
                    throws SQLException

  Description copied from interface: `Statement`
  Executes the given SQL statement, which may return multiple results. In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

  The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

  Specified by:
    `execute` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `sql` - any SQL statement
  Returns:
    `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
  See Also:
    `Statement.getResultSet()`, `Statement.getUpdateCount()`, `Statement.getMoreResults()`

### executeUpdate

    public int executeUpdate(String sql,
                             int autoGeneratedKeys)
                      throws SQLException

  Description copied from interface: `Statement`
  Executes the given SQL statement and signals the driver with the given flag about whether the auto-generated keys produced by this `Statement` object should be made available for retrieval.

  Specified by:
    `executeUpdate` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `sql` - must be an SQL `INSERT`, `UPDATE` or `DELETE` statement or an SQL statement that returns nothing
    `autoGeneratedKeys` - a flag indicating whether auto-generated keys should be made available for retrieval; one of the following constants: `Statement.RETURN_GENERATED_KEYS` `Statement.NO_GENERATED_KEYS`
  Returns:
    either the row count for `INSERT`, `UPDATE` or `DELETE` statements, or `0` for SQL statements that return nothing

### execute

    public boolean execute(String sql,
                           int autoGeneratedKeys)
                    throws SQLException

  Description copied from interface: `Statement`
  Executes the given SQL statement, which may return multiple results, and signals the driver that any auto-generated keys should be made available for retrieval. The driver will ignore this signal if the SQL statement is not an `INSERT` statement.

  In some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

  The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

  Specified by:
    `execute` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `sql` - any SQL statement
    `autoGeneratedKeys` - a constant indicating whether auto-generated keys should be made available for retrieval using the method `getGeneratedKeys`; one of the following constants: `Statement.RETURN_GENERATED_KEYS` or `Statement.NO_GENERATED_KEYS`
  Returns:
    `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
  See Also:
    `Statement.getResultSet()`, `Statement.getUpdateCount()`, `Statement.getMoreResults()`, `Statement.getGeneratedKeys()`

### executeUpdate

    public int executeUpdate(String sql,
                             int[] columnIndexes)
                      throws SQLException

  Description copied from interface: `Statement`
  Executes the given SQL statement and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. The driver will ignore the array if the SQL statement is not an `INSERT` statement.

  Specified by:
    `executeUpdate` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `sql` - an SQL `INSERT`, `UPDATE` or `DELETE` statement or an SQL statement that returns nothing, such as an SQL DDL statement
    `columnIndexes` - an array of column indexes indicating the columns that should be returned from the inserted row
  Returns:
    either the row count for `INSERT`, `UPDATE`, or `DELETE` statements, or 0 for SQL statements that return nothing

### execute

    public boolean execute(String sql,
                           int[] columnIndexes)
                    throws SQLException

  Description copied from interface: `Statement`
  Executes the given SQL statement, which may return multiple results, and signals the driver that the auto-generated keys indicated in the given array should be made available for retrieval. This array contains the indexes of the columns in the target table that contain the auto-generated keys that should be made available. The driver will ignore the array if the given SQL statement is not an `INSERT` statement.

  Under some (uncommon) situations, a single SQL statement may return multiple result sets and/or update counts. Normally you can ignore this unless you are (1) executing a stored procedure that you know may return multiple results or (2) you are dynamically executing an unknown SQL string.

  The `execute` method executes an SQL statement and indicates the form of the first result. You must then use the methods `getResultSet` or `getUpdateCount` to retrieve the result, and `getMoreResults` to move to any subsequent result(s).

  Specified by:
    `execute` in interface `Statement`
  Throws:
    `SQLException`
  Parameters:
    `sql` - any SQL statement
    `columnIndexes` - an array of the indexes of the columns in the inserted row that should be made available for retrieval by a call to the method `getGeneratedKeys`
  Returns:
    `true` if the first result is a `ResultSet` object; `false` if it is an update count or there are no results
  See Also:
    `Statement.getResultSet()`, `Statement.getUpdateCount()`, `Statement.getMoreResults()`

### getResultSet

    public ResultSet getResultSet()
                           throws SQLException

  Description copied from interface: `Statement`
  Retrieves the current result as a `ResultSet` object. This method should be called only once per result.

  Specified by:
    `getResultSet` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    the current result as a `ResultSet` object or `null` if the result is an update count or there are no more results
  See Also:
    `Statement.execute(java.lang.String)`

### getMaxRows

    public int getMaxRows()
                   throws SQLException

  Description copied from interface: `Statement`
  Retrieves the maximum number of rows that a `ResultSet` object produced by this `Statement` object can contain. If this limit is exceeded, the excess rows are silently dropped.

  Specified by:
    `getMaxRows` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    the current maximum number of rows for a `ResultSet` object produced by this `Statement` object; zero means there is no limit
  See Also:
    `Statement.setMaxRows(int)`

### close

    public void close()
               throws SQLException

  Description copied from interface: `Statement`
  Releases this `Statement` object's database and JDBC resources immediately instead of waiting for this to happen when it is automatically closed. It is generally good practice to release resources as soon as you are finished with them to avoid tying up database resources.

  Calling the method `close` on a `Statement` object that is already closed has no effect.

  Note: A `Statement` object is automatically closed when it is garbage collected. When a `Statement` object is closed, its current `ResultSet` object, if one exists, is also closed.

  Specified by:
    `close` in interface `Statement`
  Throws:
    `SQLException`

### getUpdateCount

    public int getUpdateCount()
                       throws SQLException

  Description copied from interface: `Statement`
  Retrieves the current result as an update count; if the result is a `ResultSet` object or there are no more results, -1 is returned. This method should be called only once per result.

  Specified by:
    `getUpdateCount` in interface `Statement`
  Throws:
    `SQLException`
  Returns:
    the current result as an update count; -1 if the current result is a `ResultSet` object or there are no more results
  See Also:
    `Statement.execute(java.lang.String)`

Package | Class | Use | Tree | Deprecated | Index | Help
| log4jdbc3 1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD